Index: tests/regression/Fragmentation/Automation/testsuite-fragmentation-automation-addingjobs.at
===================================================================
--- tests/regression/Fragmentation/Automation/testsuite-fragmentation-automation-addingjobs.at	(revision 469f53b02a87fe6229bfe93496f0e546f5c6bde3)
+++ tests/regression/Fragmentation/Automation/testsuite-fragmentation-automation-addingjobs.at	(revision 685e283ee3f9d16a668510a75aef7352cc2aa59d)
@@ -10,14 +10,14 @@
 
 # start service in background
-${AUTOTEST_PATH}/Fragmentation/Automation/Server --workerport $WORKERPORT --controllerport $CONTROLLERPORT &
+${AUTOTEST_PATH}/Server --workerport $WORKERPORT --controllerport $CONTROLLERPORT &
 server_pid=$!
 AT_CHECK([sleep 1], 0, [ignore], [ignore], [kill $server_pid])
 
 # add one jobs via JobAdder
-AT_CHECK([${AUTOTEST_PATH}/Fragmentation/Automation/Controller --server 127.0.0.1:$CONTROLLERPORT --command createjobs --executable "cat" --jobcommand "Nothing"], 0, [stdout], [ignore], [kill $server_pid])
+AT_CHECK([${AUTOTEST_PATH}/Controller --server 127.0.0.1:$CONTROLLERPORT --command createjobs --executable "cat" --jobcommand "Nothing"], 0, [stdout], [ignore], [kill $server_pid])
 AT_CHECK([fgrep "Sending 1 jobs ..." stdout], 0, [ignore], [ignore], [kill $server_pid])
 
 # enlist a worker to work on jobs
-${AUTOTEST_PATH}/Fragmentation/Automation/PoolWorker -v 5 --signal 2 --server 127.0.0.1:${WORKERPORT} --hostname 127.0.0.1 --listen $WORKERLISTENPORT &
+${AUTOTEST_PATH}/PoolWorker -v 5 --signal 2 --server 127.0.0.1:${WORKERPORT} --hostname 127.0.0.1 --listen $WORKERLISTENPORT &
 worker_pid=$!
 AT_CHECK([sleep 1], 0, [ignore], [ignore], [kill $server_pid $worker_pid])
@@ -27,5 +27,5 @@
 
 # shutdown
-AT_CHECK([${AUTOTEST_PATH}/Fragmentation/Automation/Controller --server 127.0.0.1:$CONTROLLERPORT --command shutdown], 0, [ignore], [ignore], [kill $server_pid] $worker_pid)
+AT_CHECK([${AUTOTEST_PATH}/Controller --server 127.0.0.1:$CONTROLLERPORT --command shutdown], 0, [ignore], [ignore], [kill $server_pid] $worker_pid)
 
 # check that server is truely down
Index: tests/regression/Fragmentation/Automation/testsuite-fragmentation-automation-checkstate.at
===================================================================
--- tests/regression/Fragmentation/Automation/testsuite-fragmentation-automation-checkstate.at	(revision 469f53b02a87fe6229bfe93496f0e546f5c6bde3)
+++ tests/regression/Fragmentation/Automation/testsuite-fragmentation-automation-checkstate.at	(revision 685e283ee3f9d16a668510a75aef7352cc2aa59d)
@@ -9,14 +9,14 @@
 
 # start service in background
-${AUTOTEST_PATH}/Fragmentation/Automation/Server --workerport $WORKERPORT --controllerport $CONTROLLERPORT &
+${AUTOTEST_PATH}/Server --workerport $WORKERPORT --controllerport $CONTROLLERPORT &
 server_pid=$!
 AT_CHECK([sleep 1], 0, [ignore], [ignore], [kill $server_pid])
 
 # check jobs
-AT_CHECK([${AUTOTEST_PATH}/Fragmentation/Automation/Controller --server 127.0.0.1:$CONTROLLERPORT --command checkresults], 0, [stdout], [ignore], [kill $server_pid])
+AT_CHECK([${AUTOTEST_PATH}/Controller --server 127.0.0.1:$CONTROLLERPORT --command checkresults], 0, [stdout], [ignore], [kill $server_pid])
 AT_CHECK([fgrep "0 jobs are calculated so far." stdout], 0, [ignore], [ignore], [kill $server_pid])
 
 # shutdown
-AT_CHECK([${AUTOTEST_PATH}/Fragmentation/Automation/Controller --server 127.0.0.1:$CONTROLLERPORT --command shutdown], 0, [ignore], [ignore], [kill $server_pid])
+AT_CHECK([${AUTOTEST_PATH}/Controller --server 127.0.0.1:$CONTROLLERPORT --command shutdown], 0, [ignore], [ignore], [kill $server_pid])
 
 # check that server is truely down
Index: tests/regression/Fragmentation/Automation/testsuite-fragmentation-automation-completerun.at
===================================================================
--- tests/regression/Fragmentation/Automation/testsuite-fragmentation-automation-completerun.at	(revision 469f53b02a87fe6229bfe93496f0e546f5c6bde3)
+++ tests/regression/Fragmentation/Automation/testsuite-fragmentation-automation-completerun.at	(revision 685e283ee3f9d16a668510a75aef7352cc2aa59d)
@@ -10,22 +10,22 @@
 
 # start service in background
-${AUTOTEST_PATH}/Fragmentation/Automation/Server --workerport $WORKERPORT --controllerport $CONTROLLERPORT &
+${AUTOTEST_PATH}/Server --workerport $WORKERPORT --controllerport $CONTROLLERPORT &
 server_pid=$!
 AT_CHECK([sleep 1], 0, [ignore], [ignore], [kill $server_pid])
 
 # add two jobs via JobAdder
-AT_CHECK([${AUTOTEST_PATH}/Fragmentation/Automation/Controller --server 127.0.0.1:$CONTROLLERPORT --command createjobs --executable "cat" --jobcommand "Nothing"], 0, [stdout], [ignore], [kill $server_pid])
+AT_CHECK([${AUTOTEST_PATH}/Controller --server 127.0.0.1:$CONTROLLERPORT --command createjobs --executable "cat" --jobcommand "Nothing"], 0, [stdout], [ignore], [kill $server_pid])
 AT_CHECK([fgrep "Sending 1 jobs ..." stdout], 0, [ignore], [ignore], [kill $server_pid])
-AT_CHECK([${AUTOTEST_PATH}/Fragmentation/Automation/Controller --server 127.0.0.1:$CONTROLLERPORT --command createjobs --executable "cat" --jobcommand "Nothing"], 0, [stdout], [ignore], [kill $server_pid])
+AT_CHECK([${AUTOTEST_PATH}/Controller --server 127.0.0.1:$CONTROLLERPORT --command createjobs --executable "cat" --jobcommand "Nothing"], 0, [stdout], [ignore], [kill $server_pid])
 AT_CHECK([fgrep "Sending 1 jobs ..." stdout], 0, [ignore], [ignore], [kill $server_pid])
-AT_CHECK([${AUTOTEST_PATH}/Fragmentation/Automation/Controller --server 127.0.0.1:$CONTROLLERPORT --command createjobs --executable "cat" --jobcommand "Nothing"], 0, [stdout], [ignore], [kill $server_pid])
+AT_CHECK([${AUTOTEST_PATH}/Controller --server 127.0.0.1:$CONTROLLERPORT --command createjobs --executable "cat" --jobcommand "Nothing"], 0, [stdout], [ignore], [kill $server_pid])
 AT_CHECK([fgrep "Sending 1 jobs ..." stdout], 0, [ignore], [ignore], [kill $server_pid])
 
 # Checking results
-AT_CHECK([${AUTOTEST_PATH}/Fragmentation/Automation/Controller --server 127.0.0.1:$CONTROLLERPORT --command checkresults], 0, [stdout], [ignore], [kill $server_pid])
+AT_CHECK([${AUTOTEST_PATH}/Controller --server 127.0.0.1:$CONTROLLERPORT --command checkresults], 0, [stdout], [ignore], [kill $server_pid])
 AT_CHECK([fgrep "#3 are waiting in the queue and #0 jobs are calculated so far." stdout], 0, [ignore], [ignore], [kill $server_pid])
 
 # enlist a worker to work on jobs
-${AUTOTEST_PATH}/Fragmentation/Automation/PoolWorker -v 5 --signal 2 --server 127.0.0.1:${WORKERPORT} --hostname 127.0.0.1 --listen $WORKERLISTENPORT &
+${AUTOTEST_PATH}/PoolWorker -v 5 --signal 2 --server 127.0.0.1:${WORKERPORT} --hostname 127.0.0.1 --listen $WORKERLISTENPORT &
 worker_pid=$!
 AT_CHECK([sleep 2], 0, [ignore], [ignore], [kill $server_pid $worker_pid])
@@ -35,9 +35,9 @@
 
 # Checking results
-AT_CHECK([${AUTOTEST_PATH}/Fragmentation/Automation/Controller --server 127.0.0.1:$CONTROLLERPORT --command checkresults], 0, [stdout], [ignore], [kill $server_pid $worker_pid])
+AT_CHECK([${AUTOTEST_PATH}/Controller --server 127.0.0.1:$CONTROLLERPORT --command checkresults], 0, [stdout], [ignore], [kill $server_pid $worker_pid])
 AT_CHECK([fgrep "#0 are waiting in the queue and #3 jobs are calculated so far." stdout], 0, [ignore], [ignore], [kill $server_pid $worker_pid])
 
 # get results
-AT_CHECK([${AUTOTEST_PATH}/Fragmentation/Automation/Controller --server 127.0.0.1:$CONTROLLERPORT --command receiveresults], 0, [stdout], [ignore], [kill $server_pid $worker_pid])
+AT_CHECK([${AUTOTEST_PATH}/Controller --server 127.0.0.1:$CONTROLLERPORT --command receiveresults], 0, [stdout], [ignore], [kill $server_pid $worker_pid])
 AT_CHECK([fgrep "Received 3 results" stdout], 0, [ignore], [ignore], [kill $server_pid $worker_pid])
 AT_CHECK([fgrep -c "Nothing" stdout], 0, [stdout], [ignore], [kill $server_pid $worker_pid])
@@ -45,9 +45,9 @@
 
 # get no more results
-AT_CHECK([${AUTOTEST_PATH}/Fragmentation/Automation/Controller --server 127.0.0.1:$CONTROLLERPORT --command receiveresults], 0, [stdout], [ignore], [kill $server_pid $worker_pid])
+AT_CHECK([${AUTOTEST_PATH}/Controller --server 127.0.0.1:$CONTROLLERPORT --command receiveresults], 0, [stdout], [ignore], [kill $server_pid $worker_pid])
 AT_CHECK([grep "Nothing" stdout], 1, [ignore], [ignore], [kill $server_pid $worker_pid])
 
 # shutdown
-AT_CHECK([${AUTOTEST_PATH}/Fragmentation/Automation/Controller --server 127.0.0.1:$CONTROLLERPORT --command shutdown], 0, [stdout], [ignore], [kill $server_pid $worker_pid])
+AT_CHECK([${AUTOTEST_PATH}/Controller --server 127.0.0.1:$CONTROLLERPORT --command shutdown], 0, [stdout], [ignore], [kill $server_pid $worker_pid])
 
 # check that server is truely down
Index: tests/regression/Fragmentation/Automation/testsuite-fragmentation-automation-enrollinpool.at
===================================================================
--- tests/regression/Fragmentation/Automation/testsuite-fragmentation-automation-enrollinpool.at	(revision 469f53b02a87fe6229bfe93496f0e546f5c6bde3)
+++ tests/regression/Fragmentation/Automation/testsuite-fragmentation-automation-enrollinpool.at	(revision 685e283ee3f9d16a668510a75aef7352cc2aa59d)
@@ -9,18 +9,18 @@
 
 # start service in background
-${AUTOTEST_PATH}/Fragmentation/Automation/Server --workerport $WORKERPORT --controllerport $CONTROLLERPORT &
+${AUTOTEST_PATH}/Server --workerport $WORKERPORT --controllerport $CONTROLLERPORT &
 server_pid=$!
 AT_CHECK([sleep 1], 0, [ignore], [ignore], [kill $server_pid])
 
 # check help of poolworker
-AT_CHECK([${AUTOTEST_PATH}/Fragmentation/Automation/PoolWorker -h], 1, [ignore], [ignore], [kill $server_pid])
+AT_CHECK([${AUTOTEST_PATH}/PoolWorker -h], 1, [ignore], [ignore], [kill $server_pid])
 
 # let worker enroll in pool
-${AUTOTEST_PATH}/Fragmentation/Automation/PoolWorker -v 5 --signal 2 --server 127.0.0.1:${WORKERPORT} --hostname 127.0.0.1 --listen $WORKERLISTENPORT &
+${AUTOTEST_PATH}/PoolWorker -v 5 --signal 2 --server 127.0.0.1:${WORKERPORT} --hostname 127.0.0.1 --listen $WORKERLISTENPORT &
 worker_pid=$!
 AT_CHECK([sleep 1], 0, [ignore], [ignore], [kill $server_pid $worker_pid])
 
 # add one jobs via JobAdder
-AT_CHECK([${AUTOTEST_PATH}/Fragmentation/Automation/Controller --server 127.0.0.1:$CONTROLLERPORT --command createjobs --executable "cat" --jobcommand "Nothing"], 0, [stdout], [ignore], [kill $server_pid $worker_pid])
+AT_CHECK([${AUTOTEST_PATH}/Controller --server 127.0.0.1:$CONTROLLERPORT --command createjobs --executable "cat" --jobcommand "Nothing"], 0, [stdout], [ignore], [kill $server_pid $worker_pid])
 AT_CHECK([fgrep "Sending 1 jobs ..." stdout], 0, [ignore], [ignore], [kill $server_pid $worker_pid])
 AT_CHECK([sleep 1], 0, [ignore], [ignore], [kill $server_pid $worker_pid])
@@ -30,5 +30,5 @@
 
 # shutdown server as well
-AT_CHECK([${AUTOTEST_PATH}/Fragmentation/Automation/Controller --server 127.0.0.1:$CONTROLLERPORT --command shutdown], 0, [ignore], [ignore], [kill $server_pid $worker_pid])
+AT_CHECK([${AUTOTEST_PATH}/Controller --server 127.0.0.1:$CONTROLLERPORT --command shutdown], 0, [ignore], [ignore], [kill $server_pid $worker_pid])
 
 # check that Server is truely down
Index: tests/regression/Fragmentation/Automation/testsuite-fragmentation-automation-getresults.at
===================================================================
--- tests/regression/Fragmentation/Automation/testsuite-fragmentation-automation-getresults.at	(revision 469f53b02a87fe6229bfe93496f0e546f5c6bde3)
+++ tests/regression/Fragmentation/Automation/testsuite-fragmentation-automation-getresults.at	(revision 685e283ee3f9d16a668510a75aef7352cc2aa59d)
@@ -9,14 +9,14 @@
 
 # start service in background
-${AUTOTEST_PATH}/Fragmentation/Automation/Server --workerport $WORKERPORT --controllerport $CONTROLLERPORT &
+${AUTOTEST_PATH}/Server --workerport $WORKERPORT --controllerport $CONTROLLERPORT &
 server_pid=$!
 AT_CHECK([sleep 1], 0, [ignore], [ignore], [kill $server_pid])
 
 # directly obtain 0 results
-AT_CHECK([${AUTOTEST_PATH}/Fragmentation/Automation/Controller --server 127.0.0.1:$CONTROLLERPORT --command receiveresults], 0, [stdout], [ignore], [kill $server_pid])
+AT_CHECK([${AUTOTEST_PATH}/Controller --server 127.0.0.1:$CONTROLLERPORT --command receiveresults], 0, [stdout], [ignore], [kill $server_pid])
 AT_CHECK([fgrep "RESULT" stdout], 1, [stdout], [ignore], [kill $server_pid])
 
 # shutdown
-AT_CHECK([${AUTOTEST_PATH}/Fragmentation/Automation/Controller --server 127.0.0.1:$CONTROLLERPORT --command shutdown], 0, [ignore], [ignore], [kill $server_pid])
+AT_CHECK([${AUTOTEST_PATH}/Controller --server 127.0.0.1:$CONTROLLERPORT --command shutdown], 0, [ignore], [ignore], [kill $server_pid])
 
 # check that server is truely down
Index: tests/regression/Fragmentation/Automation/testsuite-fragmentation-automation-mpqc-jobs.at
===================================================================
--- tests/regression/Fragmentation/Automation/testsuite-fragmentation-automation-mpqc-jobs.at	(revision 469f53b02a87fe6229bfe93496f0e546f5c6bde3)
+++ tests/regression/Fragmentation/Automation/testsuite-fragmentation-automation-mpqc-jobs.at	(revision 685e283ee3f9d16a668510a75aef7352cc2aa59d)
@@ -20,21 +20,21 @@
 
 # start service in background
-${AUTOTEST_PATH}/Fragmentation/Automation/Server --workerport $WORKERPORT --controllerport $CONTROLLERPORT &
+${AUTOTEST_PATH}/Server --workerport $WORKERPORT --controllerport $CONTROLLERPORT &
 server_pid=$!
 AT_CHECK([sleep 1], 0, [ignore], [ignore], [kill $server_pid])
 
 # add jobs
-AT_CHECK([${AUTOTEST_PATH}/Fragmentation/Automation/Controller --server 127.0.0.1:$CONTROLLERPORT --command addjobs --executable "../../mpqc" --jobfiles Job??.in], 0, [ignore], [ignore], [kill $server_pid])
+AT_CHECK([${AUTOTEST_PATH}/Controller --server 127.0.0.1:$CONTROLLERPORT --command addjobs --executable "../../mpqc" --jobfiles Job??.in], 0, [ignore], [ignore], [kill $server_pid])
 
 # enlist a worker to work on jobs
-${AUTOTEST_PATH}/Fragmentation/Automation/PoolWorker -v 5 --signal 2 --server 127.0.0.1:${WORKERPORT} --hostname 127.0.0.1 --listen $WORKERLISTENPORT &
+${AUTOTEST_PATH}/PoolWorker -v 5 --signal 2 --server 127.0.0.1:${WORKERPORT} --hostname 127.0.0.1 --listen $WORKERLISTENPORT &
 worker_pid=$!
 AT_CHECK([sleep 5], 0, [ignore], [ignore], [kill $server_pid $worker_pid])
 
 # send removeall to server such that all workers shutdown
-AT_CHECK([${AUTOTEST_PATH}/Fragmentation/Automation/Controller --server 127.0.0.1:$CONTROLLERPORT --command removeall], 0, [stdout], [ignore], [kill $server_pid $worker_pid])
+AT_CHECK([${AUTOTEST_PATH}/Controller --server 127.0.0.1:$CONTROLLERPORT --command removeall], 0, [stdout], [ignore], [kill $server_pid $worker_pid])
 
 # check number of done jobs
-AT_CHECK([${AUTOTEST_PATH}/Fragmentation/Automation/Controller --server 127.0.0.1:$CONTROLLERPORT --command receivempqc --fragment-path ${abs_top_srcdir}/tests/regression/Fragmentation/Automation/pre/], 0, [stdout], [ignore], [kill $server_pid])
+AT_CHECK([${AUTOTEST_PATH}/Controller --server 127.0.0.1:$CONTROLLERPORT --command receivempqc --fragment-path ${abs_top_srcdir}/tests/regression/Fragmentation/Automation/pre/], 0, [stdout], [ignore], [kill $server_pid])
 AT_CHECK([fgrep "There are 7 fragments" stdout], 0, [ignore], [ignore], [kill $server_pid])
 AT_CHECK([fgrep "There are 23 atoms" stdout], 0, [ignore], [ignore], [kill $server_pid])
@@ -43,5 +43,5 @@
 
 # shutdown controller socket 
-AT_CHECK([${AUTOTEST_PATH}/Fragmentation/Automation/Controller --server 127.0.0.1:$CONTROLLERPORT --command shutdown], 0, [stdout], [ignore], [kill $server_pid])
+AT_CHECK([${AUTOTEST_PATH}/Controller --server 127.0.0.1:$CONTROLLERPORT --command shutdown], 0, [stdout], [ignore], [kill $server_pid])
 
 # check that server is truely down
Index: tests/regression/Fragmentation/Automation/testsuite-fragmentation-automation-resubmitjobs.at
===================================================================
--- tests/regression/Fragmentation/Automation/testsuite-fragmentation-automation-resubmitjobs.at	(revision 469f53b02a87fe6229bfe93496f0e546f5c6bde3)
+++ tests/regression/Fragmentation/Automation/testsuite-fragmentation-automation-resubmitjobs.at	(revision 685e283ee3f9d16a668510a75aef7352cc2aa59d)
@@ -10,14 +10,14 @@
 
 # start service in background
-${AUTOTEST_PATH}/Fragmentation/Automation/Server --workerport $WORKERPORT --controllerport $CONTROLLERPORT &
+${AUTOTEST_PATH}/Server --workerport $WORKERPORT --controllerport $CONTROLLERPORT &
 server_pid=$!
 AT_CHECK([sleep 1], 0, [ignore], [ignore], [kill $server_pid])
 
 # add one always failing job via JobAdder
-AT_CHECK([${AUTOTEST_PATH}/Fragmentation/Automation/Controller --server 127.0.0.1:$CONTROLLERPORT --command createjobs --executable "/bin/false" --jobcommand "Nothing"], 0, [stdout], [ignore], [kill $server_pid])
+AT_CHECK([${AUTOTEST_PATH}/Controller --server 127.0.0.1:$CONTROLLERPORT --command createjobs --executable "/bin/false" --jobcommand "Nothing"], 0, [stdout], [ignore], [kill $server_pid])
 AT_CHECK([fgrep "Sending 1 jobs ..." stdout], 0, [ignore], [ignore], [kill $server_pid])
 
 # enlist a worker to work on jobs
-${AUTOTEST_PATH}/Fragmentation/Automation/PoolWorker -v 5 --signal 2 --server 127.0.0.1:${WORKERPORT} --hostname 127.0.0.1 --listen $WORKERLISTENPORT 2>workererr &
+${AUTOTEST_PATH}/PoolWorker -v 5 --signal 2 --server 127.0.0.1:${WORKERPORT} --hostname 127.0.0.1 --listen $WORKERLISTENPORT 2>workererr &
 worker_pid=$!
 AT_CHECK([sleep 2], 0, [ignore], [ignore], [kill $server_pid $worker_pid])
@@ -31,5 +31,5 @@
 
 # shutdown
-AT_CHECK([${AUTOTEST_PATH}/Fragmentation/Automation/Controller --server 127.0.0.1:$CONTROLLERPORT --command shutdown], 0, [ignore], [ignore], [kill $server_pid] $worker_pid)
+AT_CHECK([${AUTOTEST_PATH}/Controller --server 127.0.0.1:$CONTROLLERPORT --command shutdown], 0, [ignore], [ignore], [kill $server_pid])
 
 # check that server is truely down
Index: tests/regression/Fragmentation/Automation/testsuite-fragmentation-automation-server-shutdown.at
===================================================================
--- tests/regression/Fragmentation/Automation/testsuite-fragmentation-automation-server-shutdown.at	(revision 469f53b02a87fe6229bfe93496f0e546f5c6bde3)
+++ tests/regression/Fragmentation/Automation/testsuite-fragmentation-automation-server-shutdown.at	(revision 685e283ee3f9d16a668510a75aef7352cc2aa59d)
@@ -9,10 +9,10 @@
 
 # start service in background
-${AUTOTEST_PATH}/Fragmentation/Automation/Server --workerport $WORKERPORT --controllerport $CONTROLLERPORT &
+${AUTOTEST_PATH}/Server --workerport $WORKERPORT --controllerport $CONTROLLERPORT &
 server_pid=$!
 AT_CHECK([sleep 1], 0, [ignore], [ignore], [kill $server_pid])
 
 # shutdown server again
-AT_CHECK([${AUTOTEST_PATH}/Fragmentation/Automation/Controller --server 127.0.0.1:$CONTROLLERPORT --command shutdown], 0, [stdout], [ignore], [kill $server_pid])
+AT_CHECK([${AUTOTEST_PATH}/Controller --server 127.0.0.1:$CONTROLLERPORT --command shutdown], 0, [stdout], [ignore], [kill $server_pid])
 AT_CHECK([grep "Operation completed." stdout], 0, [stdout], [ignore], [kill $server_pid])
 
Index: tests/regression/Fragmentation/Automation/testsuite-fragmentation-automation-server-worker.at
===================================================================
--- tests/regression/Fragmentation/Automation/testsuite-fragmentation-automation-server-worker.at	(revision 469f53b02a87fe6229bfe93496f0e546f5c6bde3)
+++ tests/regression/Fragmentation/Automation/testsuite-fragmentation-automation-server-worker.at	(revision 685e283ee3f9d16a668510a75aef7352cc2aa59d)
@@ -10,13 +10,13 @@
 
 # start service in background
-${AUTOTEST_PATH}/Fragmentation/Automation/Server --workerport $WORKERPORT --controllerport $CONTROLLERPORT &
+${AUTOTEST_PATH}/Server --workerport $WORKERPORT --controllerport $CONTROLLERPORT &
 server_pid=$!
 AT_CHECK([sleep 1], 0, [ignore], [ignore], [kill $server_pid])
 
 # add one jobs 
-AT_CHECK([${AUTOTEST_PATH}/Fragmentation/Automation/Controller --server 127.0.0.1:$CONTROLLERPORT --command createjobs --executable "cat" --jobcommand "Nothing"], 0, [ignore], [ignore], [kill $server_pid])
+AT_CHECK([${AUTOTEST_PATH}/Controller --server 127.0.0.1:$CONTROLLERPORT --command createjobs --executable "cat" --jobcommand "Nothing"], 0, [ignore], [ignore], [kill $server_pid])
 
 # enlist a worker to work on jobs
-${AUTOTEST_PATH}/Fragmentation/Automation/PoolWorker -v 5 --signal 2 --server 127.0.0.1:${WORKERPORT} --hostname 127.0.0.1 --listen $WORKERLISTENPORT &
+${AUTOTEST_PATH}/PoolWorker -v 5 --signal 2 --server 127.0.0.1:${WORKERPORT} --hostname 127.0.0.1 --listen $WORKERLISTENPORT &
 worker_pid=$!
 AT_CHECK([sleep 2], 0, [ignore], [ignore], [kill $server_pid $worker_pid])
@@ -26,9 +26,9 @@
 
 # check number of done jobs
-AT_CHECK([${AUTOTEST_PATH}/Fragmentation/Automation/Controller --server 127.0.0.1:$CONTROLLERPORT --command checkresults], 0, [stdout], [ignore], [kill $server_pid])
+AT_CHECK([${AUTOTEST_PATH}/Controller --server 127.0.0.1:$CONTROLLERPORT --command checkresults], 0, [stdout], [ignore], [kill $server_pid])
 AT_CHECK([fgrep "#0 are waiting in the queue and #1 jobs are calculated so far." stdout], 0, [ignore], [ignore], [kill $server_pid])
 
 # shutdown controller socket 
-AT_CHECK([${AUTOTEST_PATH}/Fragmentation/Automation/Controller --server 127.0.0.1:$CONTROLLERPORT --command shutdown], 0, [stdout], [ignore], [kill $server_pid])
+AT_CHECK([${AUTOTEST_PATH}/Controller --server 127.0.0.1:$CONTROLLERPORT --command shutdown], 0, [stdout], [ignore], [kill $server_pid])
 
 # check that server is truely down