Index: doc/userguide/userguide.xml
===================================================================
--- doc/userguide/userguide.xml	(revision b52710e40f4aad44d3fcea2e9b3e850016a9e34d)
+++ doc/userguide/userguide.xml	(revision 0716eacb4ab3e8cd10c82739339a0d1522541346)
@@ -268,4 +268,58 @@
       one into another (with possible loss of data outside of the intersection of
       stored properties of the two involved file formats).</para>
+      <para>Note that the various formats differ in how much information they
+      can store. This restriction may come from two sources: either the file format
+      specification does not support more or the implementation is still lacking
+      specific features.</para>
+      <para>What all formats can store at least is the element per atom and a
+      position in three spatial coordinates for a single time step.</para>
+      <para>In the following we list some restrictions:</para>
+      <itemizedlist>
+        <listitem>
+          <para>Multiple time steps supported by</para>
+          <itemizedlist>
+            <listitem>
+              <para>Pdb</para>
+            </listitem>
+            <listitem>
+              <para>Tremolo (note entries allows to change over steps are: x, u, F)</para>
+            </listitem>
+            <listitem>
+              <para>Xyz</para>
+            </listitem>
+          </itemizedlist>
+        </listitem>
+        <listitem>
+          <para>Bond information supported by</para>
+          <itemizedlist>
+            <listitem>
+              <para>Pdb</para>
+            </listitem>
+            <listitem>
+              <para>Tremolo</para>
+            </listitem>
+          </itemizedlist>
+        </listitem>
+        <listitem>
+          <para>Full atom state storable (i.e. position, velocity, and force)</para>
+          <itemizedlist>
+            <listitem>
+              <para>Tremolo</para>
+            </listitem>
+          </itemizedlist>
+        </listitem>
+        <listitem>
+          <para>Domain information (however, this is not parsed only stored)</para>
+          <itemizedlist>
+            <listitem>
+              <para>Tremolo</para>
+            </listitem>
+          </itemizedlist>
+        </listitem>
+      </itemizedlist>
+      <para>You easily notice that the <productname>Tremolo</productname> format is currently
+      the most versatile. However, by advised that you need to give a specific
+    <emphasis>ATOMINFO</emphasis> line that specifies what needs to be stored,
+    see <link linkend="various-specific.set-tremolo-atomdata">set-tremolo-atomdata</link>.</para>
     </section>
   </chapter>
@@ -2641,9 +2695,36 @@
           velocities and forces as well as the atoms positions and
           element.</para>
-          <programlisting>... --set-tremolo-atomdata &quot;ATOM id element u=3 v=3 F=3&quot; \
+          <programlisting>... --set-tremolo-atomdata &quot;id element u=3 v=3 F=3&quot; \
     --reset 1
    </programlisting>
           <para>This will not append but reset the old line and fill it with
-          the given string.</para>
+          the given string. </para>
+          <para>Find a list of all keys that are also used internally in MoleCuilder below:</para>
+          <itemizedlist>
+            <listitem><para>id number - Id</para></listitem>
+            <listitem><para>chemical element - type</para></listitem>
+            <listitem><para>position - x=3</para></listitem>
+            <listitem><para>velocity - u=3</para></listitem>
+            <listitem><para>force - F=3</para></listitem>
+            <listitem><para>enumerating bonded atom ids - neighbors=4</para></listitem>
+            <listitem><para>name of atom - name</para></listitem>
+            <listitem><para>charge - Charge</para></listitem>
+          </itemizedlist>  
+          <para>Furthermore, find the rest of all available keys:</para>
+          <itemizedlist>
+            <listitem><para>stress tensor - stress</para></listitem>
+            <listitem><para>enumerating bonded atom ids for improper potential - imprData</para></listitem>
+            <listitem><para>unknown - GroupMeasureTypeNo</para></listitem>
+            <listitem><para>group association for external forces - exttype</para></listitem>
+            <listitem><para>residual name of atom (see PDB) - resName</para></listitem>
+            <listitem><para>chain Id (see PDB) - chainId</para></listitem>
+            <listitem><para>residual sequence (see PDB) - resSeq</para></listitem>
+            <listitem><para>occupancy of electron orbitals - occupancy</para></listitem>
+            <listitem><para>temperature factor - tempFactor</para></listitem>
+            <listitem><para>segment id (see PDB) - segID</para></listitem>
+            <listitem><para>different charge - charge</para></listitem>
+            <listitem><para>unknown - GrpTypeNo</para></listitem>
+            <listitem><para>enumerating bonded atom ids for torsion potential - torsion</para></listitem>
+          </itemizedlist>  
           <para>One further specific action is required when loading certain
           <productname>TREMOLO</productname> configuration files. These