Index: tests/regression/Parser/Psi3/post/empty.psi
===================================================================
--- tests/regression/Parser/Psi3/post/empty.psi	(revision 752bb4eebc964734dfa22c23ba3e97bd95f58501)
+++ tests/regression/Parser/Psi3/post/empty.psi	(revision 752bb4eebc964734dfa22c23ba3e97bd95f58501)
@@ -0,0 +1,13 @@
+psi:(
+label = "unknown job"
+jobtype = sp
+wfn = scf
+maxiter = 80
+reference = rhf
+basis = "cc-pVTZ"
+freeze_core = yes
+units = angstrom
+geometry = (
+)
+origin = (0.0 0.0 0.0)
+ )
Index: tests/regression/Parser/Psi3/post/test.psi
===================================================================
--- tests/regression/Parser/Psi3/post/test.psi	(revision 752bb4eebc964734dfa22c23ba3e97bd95f58501)
+++ tests/regression/Parser/Psi3/post/test.psi	(revision 752bb4eebc964734dfa22c23ba3e97bd95f58501)
@@ -0,0 +1,15 @@
+% Created by MoleCuilder
+psi: (
+	label = "unknown job"
+	jobtype = sp
+	wfn = scf
+	maxiter = 80
+	reference = rhf
+	basis = "cc-pVTZ"
+	freeze_core = yes
+	units = angstrom
+	geometry = (
+	( H	0	0	0 )
+	)
+	origin = (0.0	0.0	0.0)
+)
Index: tests/regression/Parser/Psi3/pre/test.xyz
===================================================================
--- tests/regression/Parser/Psi3/pre/test.xyz	(revision 752bb4eebc964734dfa22c23ba3e97bd95f58501)
+++ tests/regression/Parser/Psi3/pre/test.xyz	(revision 752bb4eebc964734dfa22c23ba3e97bd95f58501)
@@ -0,0 +1,3 @@
+1
+	Created by molecuilder on Tue Oct  6 18:34:23 2009
+H	10	10	10
Index: tests/regression/Parser/Psi3/pre/testrhf.psi
===================================================================
--- tests/regression/Parser/Psi3/pre/testrhf.psi	(revision 752bb4eebc964734dfa22c23ba3e97bd95f58501)
+++ tests/regression/Parser/Psi3/pre/testrhf.psi	(revision 752bb4eebc964734dfa22c23ba3e97bd95f58501)
@@ -0,0 +1,15 @@
+psi:(
+label = "cc-pVTZ SCF H2"
+jobtype = sp
+wfn = scf
+maxiter = 80
+reference = rhf
+basis = "cc-pVTZ"
+freeze_core = no
+units = bohr
+geometry = (
+ ( H	0	0	-0.37 )
+ ( H	0	0	0.37 )
+)
+origin = (0.0 0.0 0.0)
+ )
Index: tests/regression/Parser/Psi3/pre/testrohf.psi
===================================================================
--- tests/regression/Parser/Psi3/pre/testrohf.psi	(revision 752bb4eebc964734dfa22c23ba3e97bd95f58501)
+++ tests/regression/Parser/Psi3/pre/testrohf.psi	(revision 752bb4eebc964734dfa22c23ba3e97bd95f58501)
@@ -0,0 +1,15 @@
+psi:(
+label = "cc-pVTZ SCF H2"
+jobtype = sp
+wfn = scf
+maxiter = 80
+reference = rohf
+basis = "cc-pVTZ"
+freeze_core = no
+units = bohr
+geometry = (
+ ( H	0	0	-0.37 )
+ ( H	0	0	0.37 )
+)
+origin = (0.0 0.0 0.0)
+ )
Index: tests/regression/Parser/Psi3/pre/testtwocon.psi
===================================================================
--- tests/regression/Parser/Psi3/pre/testtwocon.psi	(revision 752bb4eebc964734dfa22c23ba3e97bd95f58501)
+++ tests/regression/Parser/Psi3/pre/testtwocon.psi	(revision 752bb4eebc964734dfa22c23ba3e97bd95f58501)
@@ -0,0 +1,21 @@
+psi:(
+label = "cc-pVTZ SCF H2"
+jobtype = sp
+wfn = scf
+maxiter = 80
+reference = twocon
+basis = "cc-pVTZ"
+multp = 1
+charge = 2
+socc = ( 1 0 1 0 0 0 0 0)
+docc = (0     0     0     0 0 0 0 0)
+subgroup = c2v
+unique_axis = x
+freeze_core = no
+units = bohr
+geometry = (
+ ( H	0	0	-0.37 )
+ ( H	0	0	0.37 )
+)
+origin = (0.0 0.0 0.0)
+ )
Index: tests/regression/Parser/Psi3/pre/testuhf.psi
===================================================================
--- tests/regression/Parser/Psi3/pre/testuhf.psi	(revision 752bb4eebc964734dfa22c23ba3e97bd95f58501)
+++ tests/regression/Parser/Psi3/pre/testuhf.psi	(revision 752bb4eebc964734dfa22c23ba3e97bd95f58501)
@@ -0,0 +1,17 @@
+psi:(
+label = "cc-pVTZ SCF H2"
+jobtype = sp
+wfn = scf
+maxiter = 80
+reference = uhf
+basis = "cc-pVTZ"
+multp = 1
+charge = 2
+freeze_core = no
+units = bohr
+geometry = (
+ ( H	0	0	-0.37 )
+ ( H	0	0	0.37 )
+)
+origin = (0.0 0.0 0.0)
+ )
Index: tests/regression/Parser/Psi3/testsuite-parser-psi3-empty.at
===================================================================
--- tests/regression/Parser/Psi3/testsuite-parser-psi3-empty.at	(revision 752bb4eebc964734dfa22c23ba3e97bd95f58501)
+++ tests/regression/Parser/Psi3/testsuite-parser-psi3-empty.at	(revision 752bb4eebc964734dfa22c23ba3e97bd95f58501)
@@ -0,0 +1,11 @@
+### parsing psi3
+
+AT_SETUP([Parser - loading empty psi3 file])
+AT_KEYWORDS([parser input psi3 emptyfile])
+
+file=empty.psi
+AT_CHECK([/bin/cp ${abs_top_srcdir}/tests/regression/Parser/Psi3/pre/$file $file], 0, [ignore], [ignore])
+AT_CHECK([chmod u+w $file], 0)
+AT_CHECK([../../molecuilder -i $file -o psi3], 0, [ignore], [ignore])
+
+AT_CLEANUP
Index: tests/regression/Parser/Psi3/testsuite-parser-psi3-load.at
===================================================================
--- tests/regression/Parser/Psi3/testsuite-parser-psi3-load.at	(revision 752bb4eebc964734dfa22c23ba3e97bd95f58501)
+++ tests/regression/Parser/Psi3/testsuite-parser-psi3-load.at	(revision 752bb4eebc964734dfa22c23ba3e97bd95f58501)
@@ -0,0 +1,66 @@
+### parsing psi3
+
+AT_SETUP([Parser - loading psi3 file])
+AT_KEYWORDS([parser load psi3])
+
+file=testrhf.psi
+AT_CHECK([../../molecuilder -i $file -o psi3 -l ${abs_top_srcdir}/tests/regression/Parser/Psi3/pre/$file], 0, [ignore], [ignore])
+AT_CHECK([diff -w -I '%.*' $file ${abs_top_srcdir}/tests/regression/Parser/Psi3/pre/$file], 0, [ignore], [ignore])
+
+file=testrohf.psi
+AT_CHECK([../../molecuilder -i $file -o psi3 -l ${abs_top_srcdir}/tests/regression/Parser/Psi3/pre/$file], 0, [ignore], [ignore])
+AT_CHECK([diff -w -I '%.*' $file ${abs_top_srcdir}/tests/regression/Parser/Psi3/pre/$file], 0, [ignore], [ignore])
+
+file=testuhf.psi
+AT_CHECK([../../molecuilder -i $file -o psi3 -l ${abs_top_srcdir}/tests/regression/Parser/Psi3/pre/$file], 0, [ignore], [ignore])
+AT_CHECK([diff -w -I '%.*' $file ${abs_top_srcdir}/tests/regression/Parser/Psi3/pre/$file], 0, [ignore], [ignore])
+
+file=testtwocon.psi
+AT_CHECK([../../molecuilder -i $file -o psi3 -l ${abs_top_srcdir}/tests/regression/Parser/Psi3/pre/$file], 0, [ignore], [ignore])
+AT_CHECK([diff -w -I '%.*' $file ${abs_top_srcdir}/tests/regression/Parser/Psi3/pre/$file], 0, [ignore], [ignore])
+
+AT_CLEANUP
+
+
+AT_SETUP([Parser - loading psi3 file with Undo])
+AT_KEYWORDS([parser load psi3 undo])
+
+file=testrhf.psi
+AT_CHECK([../../molecuilder -i $file -o psi3 -l ${abs_top_srcdir}/tests/regression/Parser/Psi3/pre/$file --undo], 0, [ignore], [ignore])
+AT_CHECK([diff -w -I '%.*' $file ${abs_top_srcdir}/tests/regression/Parser/Psi3/post/empty.psi], 0, [ignore], [ignore])
+
+file=testrohf.psi
+AT_CHECK([../../molecuilder -i $file -o psi3 -l ${abs_top_srcdir}/tests/regression/Parser/Psi3/pre/$file --undo], 0, [ignore], [ignore])
+AT_CHECK([diff -w -I '%.*' $file ${abs_top_srcdir}/tests/regression/Parser/Psi3/post/empty.psi], 0, [ignore], [ignore])
+
+file=testuhf.psi
+AT_CHECK([../../molecuilder -i $file -o psi3 -l ${abs_top_srcdir}/tests/regression/Parser/Psi3/pre/$file --undo], 0, [ignore], [ignore])
+AT_CHECK([diff -w -I '%.*' $file ${abs_top_srcdir}/tests/regression/Parser/Psi3/post/empty.psi], 0, [ignore], [ignore])
+
+file=testtwocon.psi
+AT_CHECK([../../molecuilder -i $file -o psi3 -l ${abs_top_srcdir}/tests/regression/Parser/Psi3/pre/$file --undo], 0, [ignore], [ignore])
+AT_CHECK([diff -w -I '%.*' $file ${abs_top_srcdir}/tests/regression/Parser/Psi3/post/empty.psi], 0, [ignore], [ignore])
+
+AT_CLEANUP
+
+
+AT_SETUP([Parser - loading psi3 file with Redo])
+AT_KEYWORDS([parser load psi3 redo])
+
+file=testrhf.psi
+AT_CHECK([../../molecuilder -i $file -o psi3 -l ${abs_top_srcdir}/tests/regression/Parser/Psi3/pre/$file --undo --redo], 0, [ignore], [ignore])
+AT_CHECK([diff -w -I '%.*' $file ${abs_top_srcdir}/tests/regression/Parser/Psi3/pre/$file], 0, [ignore], [ignore])
+
+file=testrohf.psi
+AT_CHECK([../../molecuilder -i $file -o psi3 -l ${abs_top_srcdir}/tests/regression/Parser/Psi3/pre/$file --undo --redo], 0, [ignore], [ignore])
+AT_CHECK([diff -w -I '%.*' $file ${abs_top_srcdir}/tests/regression/Parser/Psi3/pre/$file], 0, [ignore], [ignore])
+
+file=testuhf.psi
+AT_CHECK([../../molecuilder -i $file -o psi3 -l ${abs_top_srcdir}/tests/regression/Parser/Psi3/pre/$file --undo --redo], 0, [ignore], [ignore])
+AT_CHECK([diff -w -I '%.*' $file ${abs_top_srcdir}/tests/regression/Parser/Psi3/pre/$file], 0, [ignore], [ignore])
+
+file=testtwocon.psi
+AT_CHECK([../../molecuilder -i $file -o psi3 -l ${abs_top_srcdir}/tests/regression/Parser/Psi3/pre/$file --undo --redo], 0, [ignore], [ignore])
+AT_CHECK([diff -w -I '%.*' $file ${abs_top_srcdir}/tests/regression/Parser/Psi3/pre/$file], 0, [ignore], [ignore])
+
+AT_CLEANUP
Index: tests/regression/Parser/Psi3/testsuite-parser-psi3-save.at
===================================================================
--- tests/regression/Parser/Psi3/testsuite-parser-psi3-save.at	(revision 752bb4eebc964734dfa22c23ba3e97bd95f58501)
+++ tests/regression/Parser/Psi3/testsuite-parser-psi3-save.at	(revision 752bb4eebc964734dfa22c23ba3e97bd95f58501)
@@ -0,0 +1,10 @@
+### parsing psi3
+
+AT_SETUP([Parser - saving psi3 from loaded xyz file])
+AT_KEYWORDS([parser output psi3 xyz])
+
+file=test.psi
+AT_CHECK([../../molecuilder -l ${abs_top_srcdir}/tests/regression/Parser/Psi3/pre/test.xyz --output $file], 0, [ignore], [ignore])
+AT_CHECK([diff $file ${abs_top_srcdir}/tests/regression/Parser/Psi3/post/$file], 0, [ignore], [ignore])
+
+AT_CLEANUP
Index: tests/regression/Parser/testsuite-parser.at
===================================================================
--- tests/regression/Parser/testsuite-parser.at	(revision c8b17b55097e09730f211d414d01a4b65d6e8a5b)
+++ tests/regression/Parser/testsuite-parser.at	(revision 752bb4eebc964734dfa22c23ba3e97bd95f58501)
@@ -30,4 +30,9 @@
 m4_include([Parser/Pdb/testsuite-parser-pdb-load-various.at])
 
+# parsing mpqc
+m4_include([Parser/Psi3/testsuite-parser-psi3-empty.at])
+m4_include([Parser/Psi3/testsuite-parser-psi3-load.at])
+m4_include([Parser/Psi3/testsuite-parser-psi3-save.at])
+
 # parsing tremolo
 m4_include([Parser/Tremolo/testsuite-parser-tremolo-empty.at])